--- old/usr/src/lib/libmlrpc/common/ndr_client.c	Sun Mar 18 01:12:58 2018
+++ new/usr/src/lib/libmlrpc/common/ndr_client.c	Sun Mar 18 01:12:58 2018
@@ -21,6 +21,8 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
  */
 
 #include <sys/errno.h>
@@ -27,8 +29,7 @@
 #include <string.h>
 #include <strings.h>
 
-#include <smbsrv/libsmb.h>
-#include <smbsrv/libmlrpc.h>
+#include <libmlrpc.h>
 
 #define	NDR_DEFAULT_FRAGSZ	8192
 #define	NDR_MULTI_FRAGSZ	(60 * 1024)
@@ -38,10 +39,9 @@
 static int ndr_clnt_get_frag(ndr_client_t *, ndr_xa_t *, ndr_common_header_t *);
 
 int
-ndr_clnt_bind(ndr_client_t *clnt, const char *service_name,
+ndr_clnt_bind(ndr_client_t *clnt, ndr_service_t *msvc,
     ndr_binding_t **ret_binding_p)
 {
-	ndr_service_t		*msvc;
 	ndr_binding_t		*mbind;
 	ndr_xa_t		mxa;
 	ndr_bind_hdr_t		*bhdr;
@@ -52,10 +52,6 @@
 
 	bzero(&mxa, sizeof (mxa));
 
-	msvc = ndr_svc_lookup_name(service_name);
-	if (msvc == NULL)
-		return (NDR_DRC_FAULT_API_SERVICE_INVALID);
-
 	mxa.binding_list = clnt->binding_list;
 	if ((mbind = ndr_svc_new_binding(&mxa)) == NULL)
 		return (NDR_DRC_FAULT_API_BIND_NO_SLOTS);
@@ -140,7 +136,6 @@
 ndr_clnt_call(ndr_binding_t *mbind, int opnum, void *params)
 {
 	ndr_client_t		*clnt = mbind->clnt;
-	ndr_service_t		*msvc = mbind->service;
 	ndr_xa_t		mxa;
 	ndr_request_hdr_t	*reqhdr;
 	ndr_common_header_t	*rsphdr;
@@ -147,9 +142,6 @@
 	unsigned long		recv_pdu_scan_offset;
 	int			rc;
 
-	if (ndr_svc_lookup_name(msvc->name) == NULL)
-		return (NDR_DRC_FAULT_API_SERVICE_INVALID);
-
 	bzero(&mxa, sizeof (mxa));
 	mxa.ptype = NDR_PTYPE_REQUEST;
 	mxa.opnum = opnum;
